/**
 * webEdition SDK
 *
 * webEdition CMS
 * $Rev: 8784 $
 * $Author: mokraemer $
 * $Date: 2014-12-18 13:57:57 +0100 (Thu, 18 Dec 2014) $
 *
 * This source is part of the webEdition SDK. The webEdition SDK is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU Lesser General Public License can be found at
 * http://www.gnu.org/licenses/lgpl-3.0.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionSDK/License.txt
 *
 *
 * @category   we
 * @package    we_ui
 * @subpackage we_ui_controls
 * @license    http://www.gnu.org/licenses/lgpl-3.0.html  LGPL
 */


/**
 * Class for handling we_ui_controls_Label Element
 *
 * @category   we
 * @package    we_ui
 * @subpackage we_ui_controls
 * @license    http://www.gnu.org/licenses/lgpl-3.0.html  LGPL
 */
we_ui_controls_Label = new Object();

/**
 * enables / disables Label
 *
 *@static
 *@param {object|string} idOrObject id or reference of Label
 *@param {boolean} disabled flag that indicates if Label is disabled or not
 *@return void
 */
we_ui_controls_Label.setDisabled = function(idOrObject, disabled)
{
	var element = idOrObject;
	if (typeof (element) != "object") {
		element = document.getElementById(idOrObject);
	}
	if (disabled) {
		element.className = "we_ui_controls_Label_disabled";
	}
	else {
		element.className = "we_ui_controls_Label";
	}
}