<?php

/**
 * webEdition CMS
 *
 * $Rev: 7749 $
 * $Author: mokraemer $
 * $Date: 2014-06-14 17:24:32 +0200 (Sat, 14 Jun 2014) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
we_base_moduleInfo::isActive(we_base_moduleInfo::USERS);
class rpcPingCmd extends rpcCmd{

	function execute(){
		$resp = new rpcResponse();

		if($_SESSION["user"]["ID"]){
			$GLOBALS['DB_WE']->query('UPDATE ' . USER_TABLE . ' SET Ping=UNIX_TIMESTAMP(NOW()) WHERE ID=' . intval($_SESSION["user"]["ID"]));
			$GLOBALS['DB_WE']->query('UPDATE ' . LOCK_TABLE . ' SET lockTime=NOW() + INTERVAL ' . (we_base_constants::PING_TIME + we_base_constants::PING_TOLERANZ) . ' SECOND WHERE UserID=' . intval($_SESSION["user"]["ID"]) . ' AND sessionID="' . session_id() . '"');
		}

		if(defined('MESSAGING_SYSTEM')){
			$messaging = new we_messaging_messaging($we_transaction);
			$messaging->set_login_data($_SESSION["user"]["ID"], $_SESSION["user"]["Username"]);
			$messaging->add_msgobj('we_message', 1);
			$messaging->add_msgobj('we_todo', 1);

			$resp->setData('newmsg_count', $messaging->used_msgobjs['we_message']->get_newmsg_count());
			$resp->setData('newtodo_count', $messaging->used_msgobjs['we_todo']->get_newmsg_count());
		}

		$users_online = new we_users_online();

		$resp->setData('users', $users_online->getUsers());
		$resp->setData('num_users', $users_online->getNumUsers());

		$aDatTblPref = we_base_preferences::getUserPref('cockpit_dat'); // array as saved in the prefs
		$aDat = $aDatTblPref ? unserialize($aDatTblPref) : array();
		foreach($aDat as $d){
			foreach($d as $aProps){
				if($aProps[0] === 'mfd'){
					include(WE_INCLUDES_PATH . 'we_widgets/mod/mfd.php');
					$resp->setData('mfd_data', $lastModified);
				}
			}
		}
		return $resp;
	}

}
