<?php

/**
 * webEdition CMS
 *
 * $Rev: 8670 $
 * $Author: mokraemer $
 * $Date: 2014-12-03 12:24:15 +0100 (Wed, 03 Dec 2014) $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @category   webEdition
 * @package none
 * @license    http://www.gnu.org/copyleft/gpl.html  GPL
 */
function we_tag_ifDoctype($attribs){
	if(($foo = attributFehltError($attribs, 'doctypes', __FUNCTION__))){
		print($foo);
		return false;
	}
	$matchArr = weTag_getAttribute('doctypes', $attribs, array(), we_base_request::FILELISTA);

	$docAttr = weTag_getAttribute('doc', $attribs, 'self', we_base_request::STRING);

	if($docAttr === 'listview' && isset($GLOBALS['lv'])){
		$doctype = $GLOBALS['lv']->f('wedoc_DocType');
	} else {
		$doc = we_getDocForTag($docAttr);
		if($doc instanceof we_template){
			return false;
		}
		$doctype = $doc->DocType;
	}

	if(isset($doctype) && $doctype != false){
		foreach($matchArr as $match){
			if($doctype == f('SELECT ID FROM ' . DOC_TYPES_TABLE . ' WHERE DocType="' . $GLOBALS['DB_WE']->escape($match) . '"', 'ID', $GLOBALS['DB_WE'])){
				return true;
			}
		}
	}
	return false;
}
